import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _createClass from "@babel/runtime/helpers/createClass";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { GroupedEvent } from '@castore/core';
import { getApiMethod, compileOperation } from "./utils/getApiMethod";
import { getSwaggerClient } from "./utils/getSwaggerClient";
export var HttpEventStorageAdapter = /*#__PURE__*/_createClass(function HttpEventStorageAdapter(_ref) {
  var _this = this;

  var swagger = _ref.swagger;

  _classCallCheck(this, HttpEventStorageAdapter);

  _defineProperty(this, "getEvents", void 0);

  _defineProperty(this, "listAggregateIds", void 0);

  _defineProperty(this, "pushEvent", void 0);

  _defineProperty(this, "pushEventGroup", void 0);

  _defineProperty(this, "groupEvent", void 0);

  _defineProperty(this, "swagger", void 0);

  _defineProperty(this, "client", void 0);

  _defineProperty(this, "getApiMethod", void 0);

  _defineProperty(this, "getEventsMethod", void 0);

  _defineProperty(this, "listAggregateIdsMethod", void 0);

  this.swagger = swagger;
  this.client = getSwaggerClient({
    swagger: this.swagger
  });
  this.getApiMethod = getApiMethod(this.swagger);
  this.getEventsMethod = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
    var client, getEventsPath, getEvents;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _this.client;

          case 2:
            client = _context.sent;
            getEventsPath = _this.getApiMethod('getEvents');

            if (!(getEventsPath === undefined)) {
              _context.next = 6;
              break;
            }

            throw new Error('getEvents operation not found');

          case 6:
            getEvents = compileOperation(client, getEventsPath);
            return _context.abrupt("return", getEvents);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  this.listAggregateIdsMethod = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
    var client, listAggregateIdsPath, listAggregateIds;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _this.client;

          case 2:
            client = _context2.sent;
            listAggregateIdsPath = _this.getApiMethod('listAggregateIds');

            if (!(listAggregateIdsPath === undefined)) {
              _context2.next = 6;
              break;
            }

            throw new Error('listAggregateIds operation not found');

          case 6:
            listAggregateIds = compileOperation(client, listAggregateIdsPath);
            return _context2.abrupt("return", listAggregateIds);

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  this.getEvents = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(aggregateId, _, options) {
      var _ref5, body;

      return _regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return _this.getEventsMethod(_objectSpread({
                aggregateId: aggregateId
              }, options));

            case 2:
              _ref5 = _context3.sent;
              body = _ref5.body;
              return _context3.abrupt("return", body);

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x, _x2, _x3) {
      return _ref4.apply(this, arguments);
    };
  }();

  this.listAggregateIds = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4() {
    var _ref7, body;

    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return _this.listAggregateIdsMethod();

          case 2:
            _ref7 = _context4.sent;
            body = _ref7.body;
            return _context4.abrupt("return", body);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })); // We do not implement event groups in this adapter

  this.groupEvent = function (event) {
    return new GroupedEvent({
      event: event,
      eventStorageAdapter: _this
    });
  };

  this.pushEvent = function () {
    return new Promise(function (_, reject) {
      return reject('Not implemented yet');
    });
  };

  this.pushEventGroup = function () {
    return new Promise(function (_, reject) {
      return reject('Not implemented yet');
    });
  };
});
//# sourceMappingURL=adapter.js.map