import _slicedToArray from "@babel/runtime/helpers/slicedToArray";

var getSwaggerPaths = function getSwaggerPaths(paths) {
  if (paths === undefined) {
    return undefined;
  }

  return Object.entries(paths).flatMap(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        path = _ref2[0],
        verbs = _ref2[1];

    if (verbs === undefined) {
      return [];
    }

    return Object.entries(verbs).map(function (_ref3) {
      var _ref4 = _slicedToArray(_ref3, 2),
          verb = _ref4[0],
          route = _ref4[1];

      return {
        path: path,
        verb: verb,
        route: route
      };
    });
  });
};

export var getApiMethod = function getApiMethod(swagger) {
  return function (methodName) {
    var paths = getSwaggerPaths(swagger.paths);

    if (paths === undefined) {
      return undefined;
    }

    var methodPath = paths.find(function (_ref5) {
      var route = _ref5.route;
      return (// @ts-ignore x-castore-operationId is an extension of the openAPI spec
        route['x-castore-operationId'] === methodName || route.operationId === methodName
      );
    });
    return methodPath;
  };
};
export var compileOperation = function compileOperation(client, path) {
  var _route$tags$, _route$tags, _client$apis$tag;

  var route = path.route;
  var tag = (_route$tags$ = (_route$tags = route.tags) === null || _route$tags === void 0 ? void 0 : _route$tags[0]) !== null && _route$tags$ !== void 0 ? _route$tags$ : 'default';
  var operationId = route.operationId;
  var method = (_client$apis$tag = client.apis[tag]) === null || _client$apis$tag === void 0 ? void 0 : _client$apis$tag[operationId];
  return method;
};
//# sourceMappingURL=getApiMethod.js.map