import { OpenAPI } from 'openapi-types';
import { EventStorageAdapter, EventsQueryOptions } from '@castore/core';
import { SwaggerClient, Path } from './utils/types';
export declare class HttpEventStorageAdapter implements EventStorageAdapter {
    getEvents: EventStorageAdapter['getEvents'];
    listAggregateIds: EventStorageAdapter['listAggregateIds'];
    pushEvent: EventStorageAdapter['pushEvent'];
    pushEventGroup: EventStorageAdapter['pushEventGroup'];
    groupEvent: EventStorageAdapter['groupEvent'];
    swagger: OpenAPI.Document;
    client: Promise<SwaggerClient>;
    getApiMethod: (method: string) => Path | undefined;
    getEventsMethod: ({ aggregateId, options, }: {
        aggregateId: string;
        options?: EventsQueryOptions;
    }) => Promise<unknown>;
    listAggregateIdsMethod: () => Promise<unknown>;
    constructor({ swagger }: {
        swagger: OpenAPI.Document;
    });
}
//# sourceMappingURL=adapter.d.ts.map