export declare const swagger: {
    swagger: string;
    openapi: string;
    info: {
        title: string;
        description: string;
        version: string;
        license: {
            name: string;
        };
    };
    basePath: string;
    tags: {
        name: string;
    }[];
    schemes: string[];
    paths: {
        '/event': {
            get: {
                tags: string[];
                operationId: string;
                produces: string[];
                responses: {
                    '200': {
                        description: string;
                        schema: {
                            $ref: string;
                        };
                    };
                    '400': {
                        description: string;
                    };
                    '404': {
                        description: string;
                    };
                };
            };
        };
    };
    definitions: {
        Page: {
            type: string;
            properties: {
                count: {
                    type: string;
                    format: string;
                };
                next: {
                    type: string;
                };
                previous: {
                    type: string;
                };
                results: {
                    type: string;
                    items: {
                        type: string;
                        properties: {
                            name: {
                                type: string;
                            };
                            url: {
                                type: string;
                            };
                        };
                    };
                };
            };
        };
        Event: {
            type: string;
            properties: {
                id: {
                    type: string;
                    format: string;
                };
                height: {
                    type: string;
                    format: string;
                };
                weight: {
                    type: string;
                    format: string;
                };
                name: {
                    type: string;
                    example: string;
                };
                sprites: {
                    $ref: string;
                };
            };
        };
    };
};
//# sourceMappingURL=mocks.test.d.ts.map